function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { number, string, bool, any } from 'prop-types';

import './styles.css';

var Cinemagraph = function (_Component) {
  _inherits(Cinemagraph, _Component);

  function Cinemagraph(props) {
    _classCallCheck(this, Cinemagraph);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {};
    return _this;
  }

  Cinemagraph.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.initBannerVideoSize('.video-container .poster img');
    this.initBannerVideoSize('.video-container .filter');
    this.initBannerVideoSize('.video-container video');

    window.addEventListener('resize', function () {
      _this2.scaleBannerVideoSize('.video-container .poster img');
      _this2.scaleBannerVideoSize('.video-container .filter');
      _this2.scaleBannerVideoSize('.video-container video');
    });
  };

  Cinemagraph.prototype.initBannerVideoSize = function initBannerVideoSize(elements) {
    document.querySelectorAll(elements).forEach(function (element) {
      element.setAttribute('data-height', parseInt(element.height, 10) + 'px');
      element.setAttribute('data-width', parseInt(element.width, 10) + 'px');
    });

    this.scaleBannerVideoSize(elements);
  };

  Cinemagraph.prototype.scaleBannerVideoSize = function scaleBannerVideoSize(elements) {
    var _this3 = this;

    var windowWidth = window.innerWidth;
    var windowHeight = window.innerHeight + 5;
    var videoWidth = 0;
    var videoHeight = 0;

    document.querySelectorAll(elements).forEach(function (element) {
      var videoAspectRatio = element.getAttribute('data-height') / element.getAttribute('data-width');

      _this3.innerWidth = windowWidth;

      if (windowWidth < 1000) {
        videoHeight = windowHeight;
        videoWidth = videoHeight / videoAspectRatio;
        document.querySelectorAll('body')[0].style.marginTop = 0;
        document.querySelectorAll('body')[0].style.marginLeft = -(videoWidth - windowWidth) / 2 + 'px';

        document.querySelectorAll('body')[0].innerWidth = videoWidth + 'px';
        document.querySelectorAll('body')[0].innerHeight = videoHeight + 'px';
      }

      document.querySelectorAll('.homepage-hero-module .video-container video')[0].classList.add('fadeIn');
      document.querySelectorAll('.homepage-hero-module .video-container video')[0].classList.add('animated');
    });
  };

  Cinemagraph.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'homepage-hero-module' },
      React.createElement(
        'div',
        {
          className: 'video-container',
          style: {
            height: this.props.height + 'vw',
            maxHeight: this.props.maxHeight + 'vh'
          }
        },
        React.createElement(
          'div',
          { className: 'poster hidden' },
          React.createElement('img', { src: this.props.fallbackImage, alt: this.props.fallbackImageAlt }),
          ' '
        ),
        ' ',
        React.createElement('div', { className: 'filter' }),
        ' ',
        React.createElement(
          'video',
          {
            autoPlay: true,
            playsInline: true,
            muted: true,
            loop: true,
            className: '\n              fillWidth\n              ' + (this.props.isBlackAndWhite ? 'cinemagraph-black-and-white' : '') + '\n              ' + (this.props.isSepia ? 'cinemagraph-sepia' : '') + '\n              ' + (this.props.isBlurred ? 'cinemagraph-blur' : '') + '\n        '
          },
          React.createElement('source', { src: this.props.mp4Source, type: 'video/mp4' }),
          ' Your browser does not support the video tag. I suggest you upgrade your browser.',
          ' ',
          React.createElement('source', { src: this.props.webmSource, type: 'video/webm' }),
          'Your browser does not support the video tag. I suggest you upgrade your browser.'
        ),
        ' '
      ),
      ' '
    );
  };

  return Cinemagraph;
}(Component);

Cinemagraph.propTypes = process.env.NODE_ENV !== "production" ? {
  height: number.isRequired,
  maxHeight: number.isRequired,
  fallbackImage: any,
  fallbackImageAlt: string,
  mp4Source: any,
  webmSource: any,
  isBlackAndWhite: bool,
  isSepia: bool,
  isBlurred: bool
} : {};

export { Cinemagraph };
export default Cinemagraph;